//*****************************************************************************
// EEPROM Ѵʰץե륷ƥ
//*****************************************************************************/
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <avr/eeprom.h> 
#include "fs.h"
#include "common.h"

// Хѿ
uint8_t fs_filename;
uint8_t *fs_head_addr, *fs_final_addr;
uint16_t fs_size;
uint8_t fs_wopenflag;
uint8_t *fs_pt;

// 
void fs_init(void) {
	// fs_final_addr 뤿ᡢŬʥե꡼ɥץ󤹤
	fs_ropen(0);
}

/*
//  0 Υեõƺ
void fs_zerodelete(void) {
	uint8_t i;
	for (i=0; i<254; i++) {
		fs_ropen(i);
		if (fs_size==0) fs_delete(i);
	}
}
*/

// եõ,꡼ɥץ
uint8_t fs_ropen(uint8_t fn) {
	uint16_t tmp_size;
	uint8_t *tmp_addr;

	// ťץȽ(񤭹ߥץɤ߹ߥץǤʤ)
	// if (fs_wopenflag==FS_OPENED) return FS_ALREADYOPENED;

	// 夫 open ͭ
	fs_wopenflag=FS_CLOSED;

	// եѥ᡼
	tmp_addr = EEPROM_FS; 
	fs_size  = 0xffff;
	// õ
	while (1) {
		// ǽ֤ fs_final_addr 
		fs_final_addr = tmp_addr;
		// ɤ߹
		tmp_size=eeprom_read_word((uint16_t *)(tmp_addr+1));
		// ǽեȯǽλ
		if (tmp_size==0xffff) break;
		// եֹץå
		if (eeprom_read_byte(tmp_addr) == fn) {
			fs_head_addr = tmp_addr;
			fs_pt        = tmp_addr+3;
			fs_size      = tmp_size;
		}
		// Υ֤
		tmp_addr += tmp_size+3;
		// ɥ쥹ϰϤåõ̵¥롼פɻ
		if (tmp_addr>EEPROM_FS+FS_SIZE-3) break;
	} 
	// ꥶȥ
	if (fs_size==0xffff) return FS_NOTFOUND;
	else                 return FS_OK;
}

// եκ
uint8_t fs_delete(uint8_t fn) {
	uint8_t *src, *dst;
	uint8_t result;

	// եõ
	result = fs_ropen(fn);
	if (result != FS_OK) return result;

	// EEPROM Υԡ
	dst = fs_head_addr;
	src = fs_pt + fs_size;
	while(src<fs_final_addr+3) {
		eeprom_write_byte(dst, eeprom_read_byte(src));
		src++; dst++;
	}

	// fs_final_addr ǡ+إåʬ餹
	// fs_final_addr -= (fs_size+3);
	// fs_final_addr κƷ׻Τõ
	fs_ropen(0);

	// ꥶȥ
	return FS_OK;
}

// 饤ȥץ
uint8_t fs_wopen(uint8_t fn) {
	// ťץȽ: ѻ
	// if (fs_wopenflag==FS_OPENED) return FS_ALREADYOPENED;

	// Ʊե뤬Ǥ¸ߤƤϺ
	fs_delete(fn);
	// եѥ᡼
	fs_filename   = fn;
	fs_head_addr  = fs_final_addr;
	fs_pt         = fs_head_addr+3;
	fs_size       = 0;
	fs_final_addr = fs_pt+1;
	fs_wopenflag = FS_OPENED;
	return FS_OK;
}

// 
uint8_t fs_wclose(void) {
	if (fs_wopenflag == FS_CLOSED) return FS_NOTFOUND;
	fs_wopenflag = FS_CLOSED;
	// Сå	(-1 Ƥ礦ɻȤڤ륱)
	fs_final_addr = fs_head_addr + fs_size + 3;
	if (fs_final_addr > EEPROM_FS + FS_SIZE-3-1) {
		fs_final_addr = fs_head_addr;
		return FS_DISKFULL;
	}
	// EEPROM եإåι
	eeprom_write_byte(fs_head_addr,   fs_filename);
	eeprom_write_word((uint16_t*)(fs_head_addr+1), fs_size);
	eeprom_write_byte(fs_final_addr + 0, 0xff);
	eeprom_write_byte(fs_final_addr + 1, 0xff);
	eeprom_write_byte(fs_final_addr + 2, 0xff);
	// ꥶȥ
	return FS_OK;
}

// 1ХȽ񤭹
uint8_t fs_write_b(uint8_t val) {
	fs_size++;
	if (fs_wopenflag == FS_CLOSED)   return FS_NOTFOUND;
	if (fs_pt >= EEPROM_FS+FS_SIZE-3) return FS_DISKFULL;
	eeprom_write_byte(fs_pt, val);
	fs_pt++;
	fs_final_addr++;
	return FS_OK;
}

// 1Хɤ߹
uint8_t fs_read_b(void) {
	return eeprom_read_byte(fs_pt++);
}

// ɽ񤭹
uint8_t fs_write_w(uint16_t val) {
	uint8_t result;
	// 
	result = fs_write_b(val & 0xff);
	if (result != FS_OK) return result;
	// 
	return fs_write_b(val>>8);
}

// ɤ߹
uint16_t fs_read_w(void) {
	uint8_t l;
	l = fs_read_b();
	return (l | (	fs_read_b()<<8));
}

/*
// ʸɤ߹
// maxlen: üNULLʸޤ᤿ʸ
char* fs_str_r(char* str, uint8_t fn, uint16_t maxlen) {
  uint16_t pt=0;
  if (fs_ropen(fn)==FS_OK) {
    while(pt<maxlen-1) {
      str[pt] = fs_read_b();
      if (str[pt]==0xff || str[pt]=='\0') break;
      pt++;
    }
  }
  str[pt]='\0';
	return str;
}


// ʸν񤭹
uint8_t fs_str_w(char *str, uint8_t fn) {
	char c;
	uint16_t pt=0;
	if (fs_wopen(fn)==FS_OK) {
		do {
			c=str[pt];
			fs_write_b(c);
			pt++;
		} while (c!='\0');
		return fs_wclose();
	}
	return FS_NOTFOUND;
}
*/


// ΥեΥ֤
// ա˲Ū fs_ropen() ƤΤǡեݥ󥿤Ƭ֤˰ưޤ
uint16_t fs_filesize(uint8_t fn) {
	if (fs_ropen(fn)!=FS_OK) return 0;
	return fs_size;
}


// ̤֤
uint16_t fs_free(void) {
	int16_t size;
	size = EEPROM_FS+FS_SIZE-3-fs_final_addr-3;
	if (size<0) size=0;
	return (uint16_t)size;
}

// եΥå໻
unsigned char getCheckSum(unsigned char fn) {
	unsigned char sum = fn;
	if (fs_ropen(fn) != FS_OK) return 0;
	sum ^= (unsigned char)(fs_size & 0xff);
	sum ^= (unsigned char)((fs_size & 0xff00)>>8);
	while (!fs_EOF()) {
		sum ^= fs_read_b();
	}
	return sum;
}
